package ch.usi.inf.sape.tracer.analyzer.cdg;

import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.InsnList;

public class ASMInstructionList implements InstructionList<AbstractInsnNode>{

	private final InsnList insns;
	
	
	public ASMInstructionList(InsnList insns) {
		this.insns = insns;
	}

	@Override
	public int size() {
		return insns.size();
	}

	@Override
	public int indexOf(AbstractInsnNode insn) {
		return insns.indexOf(insn);
	}

	@Override
	public ASMInstruction get(int index) {
		return new ASMInstruction(insns.get(index));
	}

}
