package ch.usi.inf.sape.tracer.analyzer.cdg;


public class ControlFlowGraph<V,E> extends GraphMatrixDirected<V, E> {

	/**
	 * exit node for this control flow graph
	 */
	private V exit;
	
	private final InstructionList<V> instructions;
	
	/**
	 * Fully qualified class name enclosing the method 
	 * represented by this CFG.
	 */
	private final String className;
	
	/**
	 * the name of the method represented by this CFG
	 */
	private final String methodName;
	
	public ControlFlowGraph(int size, 
							InstructionList<V> instructions,
							String className,
							String methodName) {
		super(size);
		this.instructions = instructions;
		this.className = className;
		this.methodName = methodName;
	}

	public V getExit(){
		return exit;
	}
	
	public void setExit(V exit){
		this.exit = exit;
	}
	
	public InstructionList<V> getInstructions(){
		return this.instructions;
	}

	/**
	 * Fully qualified class name enclosing the method 
	 * represented by this CFG.
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * the name of the method represented by this CFG
	 */
	public String getMethodName() {
		return methodName;
	}
	
}

